
fLayer struct
	DC dword 0
	bmp dword 0
fLayer ends


.data
	keybrd_buff dword 0
.code

fLoadPicture proc uses esi edi lpFileName:dword
	LOCAL imagesize,mem:dword
	
	invoke exist,lpFileName
	.if eax!=1
		invoke MessageBox,0,CADD("File Not Found"),0,0
		xor eax,eax
		dec eax
		ret
	.endif
	
	invoke filesize,lpFileName
	mov imagesize,eax
	
	invoke mAlloc,imagesize
	mov mem,eax
	
	invoke read_disk_file,lpFileName,addr mem,addr imagesize
	invoke BitmapFromMemory,mem,imagesize
	push eax
		invoke GlobalFree,mem
	pop eax
	invoke ConvertToDIB32,eax
	
	ret
fLoadPicture endp

IsPressed proc uses esi key:dword

	mov esi,keybrd_buff
	mov eax,key
	movzx eax,byte ptr[esi+eax]
	
	ret
IsPressed endp

InputKeyboadFrb proc uses esi wParam:dword,code:dword
		mov esi,keybrd_buff
		mov eax,wParam
		mov ecx,code
		mov byte ptr[esi+eax],cl
	ret
InputKeyboadFrb endp

InitKeyboard proc
	
	invoke mAlloc,512
	mov keybrd_buff,eax
	
	ret
InitKeyboard endp


PERR	PROC uses ebx edi esi	;, _API : DWORD
LOCAL	szMsgBuf[500]:BYTE

	INVOKE GetLastError
	mov	ebx, eax
	INVOKE FormatMessageA, \
		FORMAT_MESSAGE_FROM_SYSTEM,\
		NULL, \
		ebx, \					;Message Id
		LANG_NEUTRAL + SUBLANG_DEFAULT*1024, \	;Message language
		ADDR szMsgBuf, \			;Buffer to store message
		500, \					;Buffer size
		NULL					;No more arguments
	INVOKE	MessageBoxA, NULL, ADDR szMsgBuf, NULL, MB_OK

	;INVOKE	ExitProcess, -1

	ret

PERR	ENDP



fCenterWindows proc hWnd:dword,_width:dword,height:dword
	LOCAL xs,ys:dword
	LOCAL hxs,hys:dword
	
	invoke GetSystemMetrics,SM_CXSCREEN
	mov xs,eax
	shr eax,1
	mov hxs,eax
	invoke GetSystemMetrics,SM_CYSCREEN
	mov ys,eax
	shr eax,1
	mov hys,eax
	
	mov eax,_width
	shr eax,1
	sub hxs,eax
	
	mov eax,height
	shr eax,1
	sub hys,eax
	
	invoke SetWindowPos,hWnd,HWND_NOTOPMOST,hxs,hys,_width,height,NULL
	
	ret
fCenterWindows endp

