  .586
.mmx
.xmm

.model flat,stdcall
option casemap:none


literal_string		macro	lit_string
			local	local_string

			.data
			align	4
local_string		db	lit_string, 0

			.code
			exitm	<local_string>
			endm
CADD MACRO quoted_text
      LOCAL vname,lbl
        jmp lbl
          vname db quoted_text,0
        lbl:
      EXITM <ADDR vname>
    ENDM
CSTR			macro	lit_string
			exitm	<offset literal_string(lit_string)>
			endm
literal_double		macro	lit_double:vararg
			local	local_double

			.data
local_double		real8	lit_double

			.code
			exitm	<local_double>
			endm
			
literal_float		MACRO	lit_float:VARARG
			LOCAL	local_float
			.data
local_float		real4	lit_float
			.code
			EXITM	<local_float>
			ENDM

CFLT			MACRO	lit_float:VARARG
			EXITM	<literal_float(lit_float)>
			ENDM
			
CTEXT MACRO y:VARARG
	LOCAL sym

	CONST segment
		IFIDNI <y>,<>
			sym db 0
		ELSE
			sym db y,0
		ENDIF
	CONST ends

	EXITM <OFFSET sym>
ENDM

CDBL			macro	lit_double:vararg
			exitm	<literal_double(lit_double)>
			endm
    include windows.inc
   include user32.inc
   include kernel32.inc
   include gdi32.inc
   include shell32.inc
   include comdlg32.inc
   include winmm.inc
   include ole32.inc
   include msvfw32.inc
   include avifil32.inc
   include  advapi32.inc
   include wininet.inc
   include avicap32.inc
   include gdiplus.inc
   include opengl32.inc
   include OpenGLUT.inc
   include glu.inc
  
   Include masm32.inc
   include macros.inc
   include graphics.inc
  	include fFile.inc
  	 include additional.inc
   include hNullString.inc
   include 3D.inc

  
   includelib masm32.lib
   includelib gdi32.lib
   includelib user32.lib
   includelib kernel32.lib
   includelib winmm.lib
   includelib shell32.lib
	includelib	ole32.lib
	includelib advapi32.lib
	includelib msvfw32.lib
	includelib avifil32.lib
	includelib	oleaut32.lib
	includelib comdlg32.lib
	includelib wininet.lib
	includelib avicap32.lib
	includelib gdiplus.lib
	includelib opengl32.lib
	includelib glu32.lib
	includelib Graphics.lib
	includelib msvcrt.lib
	includelib Quaternions.lib
	
   
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
Draw proto hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
ShowMatrix proto hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

LoadFromText proto lptzFileName:dword
GetVertex proto :dword,:dword

FPS_Count proto hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
     m2m MACRO M1, M2
        push M2
        pop  M1
      ENDM

.data
   ClassName db "GEF",0
   AppName  db "Test",0
   
   Light_Position		real4	-0.0, 3.0, 3.5, 0.0
	Light_Diffuse		real4	1.0, 1.0, 1.0, 1.0
	Light_Ambient		real4	0.5, 0.5, 0.7, 1.0
	rot_o	real4 0.0
	
	posX real4 0.0
	posY real4 0.0
	posZ real4 0.0
	
	rotX real4 0.0
	rotY real4 0.0
	rotZ real4 0.0
	
	
.data?
	hInstance HINSTANCE ?
	CommandLine LPSTR ?
	hwnd dword ?
	mclick dword ?
	mclickup dword ?
	
	MOUSE POINT <?>
	dllhnd dword 0
	
	hDC dword 0
	hRC dword 0
	fps_cnt dword 0
	FPS dword 0
	base dword 0
	lpv dword 0
.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	
	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX 
	LOCAL msg:MSG 
	
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW\
           ,0,\
           0,600,480,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp


WndProc proc uses esi edi hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL t[256]:dword
	LOCAL t2[256]:dword
	LOCAL buff[256]:dword
	LOCAL pic_pntr:dword
	LOCAL q:qword
	LOCAL r:RECT
	LOCAL p:POINT
	LOCAL px:dword, py:dword
	LOCAL a:dword,b:dword
	
	.IF uMsg==WM_DESTROY		
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_CREATE
		
		invoke GetSystemMetrics,SM_CXSCREEN
		cmp eax,600
		jnl @f
			invoke MessageBox,hWnd,CADD("Resolution width less than 600 pixels"),CADD("Execution aborted"),MB_OK
			invoke PostQuitMessage,NULL
		@@:
		
		invoke GetSystemMetrics,SM_CYSCREEN
		cmp eax,480
		jnl @f
			invoke MessageBox,hWnd,CADD("Resolution height less than 480 pixels"),CADD("Execution aborted"),MB_OK
			invoke PostQuitMessage,NULL
		@@:
		invoke LoadLibrary,CADD("RICHED32.DLL")
		.if eax!=0
			mov dllhnd,eax
		.else
			invoke PERR
		.endif

		invoke fCenterWindows,hWnd,600,480
		; Do not remove this
		
		
		invoke fEnableOpenGL,hWnd,addr hDC,addr hRC
		invoke LoadFromText,CADD("World.txt")
		mov lpv,eax
		
	;	invoke GetVertex,lpv,1
		
	;	fld [eax].VERTEX.y
	;	fstp q
		
	;	invoke FloatToStr2,q,addr buff
	;	invoke MessageBox,0,addr buff,0,0
		
		invoke glEnable,GL_DEPTH_TEST
		invoke glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST
		invoke glHint,GL_LINE_SMOOTH_HINT,GL_NICEST
		invoke glEnable,GL_LINE_SMOOTH
		invoke gluPerspective,CDBL(45.0),CDBL(1.0),CDBL(1.0),CDBL(200.0)
	
		invoke SetTimer,hWnd,1,25,addr Draw
		
		
	.elseif uMsg==WM_SIZE
	;	invoke GetWindowRect,hWnd,addr r
	;	invoke glViewport,0,0,r.right,r.bottom
		
	.elseif uMsg==WM_MOUSEMOVE
		mov eax,lParam
		movzx edx,ax
		mov MOUSE.x,edx
		shr eax,16
		movzx edx,ax
		mov MOUSE.y,edx
		
		
	.elseif uMsg==WM_KEYUP
		
	.elseif uMsg==WM_KEYDOWN
		
	.elseif uMsg==WM_LBUTTONUP
		.if mclick==1
			;mov mclickup,0
		.endif
		mov mclick,0
		
	.elseif uMsg==WM_LBUTTONDOWN
		mov mclick,1
		mov mclickup,1
		
	.elseif uMsg==WM_USER
			
			
	.elseif uMsg==WM_COMMAND
		
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	
	
	xor eax,eax
	ret
WndProc endp

LoadFromText proc uses esi lptzFileName:dword
	LOCAL hFile:dword
	LOCAL v_cnt:dword
	LOCAL m_line:dword
	LOCAL buff[256]:dword
	LOCAL lpvertex,v_index,linepos:dword
	LOCAL q:qword
	
	invoke OpenFileFrb,lptzFileName
	mov hFile,eax
	
	; Get vertex count
	; each line which had 5 words assumed as a vertex
	invoke UMLineCount,hFile		; Use the FAST line counter
	mov m_line,eax
	
	xor ecx,ecx
	mov v_cnt,ecx
	loop_each_line:
	pushad
		inc ecx
		invoke UM_Word_Count,hFile,ecx
		.if eax==5
			inc v_cnt
		.endif
	popad
	inc ecx
	cmp ecx,m_line
	jl loop_each_line
	
;	invoke dw2a,v_cnt,addr buff
;	invoke MessageBox,0,addr buff,CADD("Vertex count:"),0
	
	xor edx,edx
	mov eax,v_cnt
	mov ecx,sizeof VERTEX
	mul ecx
	invoke mAlloc,eax
	mov lpvertex,eax
	
	xor ecx,ecx
	mov v_index,ecx
	loop_get_data:
	pushad
		inc ecx
		mov linepos,ecx
		invoke UM_Word_Count,hFile,ecx
		.if eax==5
			invoke GetWord,hFile,linepos,1			; Get the first word using the FAST function
			invoke StrToFloat,[edx].frbWordStruct.lpAddress,addr q
			mov esi,lpvertex
			add esi,v_index
			fld q
			fstp [esi].VERTEX.x
			
			invoke GetWord,hFile,linepos,2			; 
			invoke StrToFloat,[edx].frbWordStruct.lpAddress,addr q
			mov esi,lpvertex
			add esi,v_index
			fld q
			fstp [esi].VERTEX.y
			
			invoke GetWord,hFile,linepos,3			; 
			invoke StrToFloat,[edx].frbWordStruct.lpAddress,addr q
			mov esi,lpvertex
			add esi,v_index
			fld q
			fstp [esi].VERTEX.z
			
			invoke GetWord,hFile,linepos,4			; 
			invoke StrToFloat,[edx].frbWordStruct.lpAddress,addr q
			mov esi,lpvertex
			add esi,v_index
			fld q
			fstp [esi].VERTEX.u
			
			invoke GetWord,hFile,linepos,5			; 
			invoke StrToFloat,[edx].frbWordStruct.lpAddress,addr q
			mov esi,lpvertex
			add esi,v_index
			fld q
			fstp [esi].VERTEX.v
			
			add v_index,sizeof VERTEX
		.endif
	popad
	inc ecx
	cmp ecx,m_line
	jl loop_get_data
	
	invoke CloseFileFrb,hFile
	mov eax,lpvertex
	
	ret
LoadFromText endp

GetVertex proc uses esi lpVertexBuffer:dword,nIndex:dword
	
	mov esi,lpVertexBuffer
	mov ecx,nIndex
	
	xor edx,edx
	mov eax,sizeof VERTEX
	mul ecx
	
	lea eax,[esi+eax]
	
	ret
GetVertex endp			; The return value is the address of the vertex buffer

Draw proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	invoke glClearColor,CFLT(0.0),CFLT(0.0),CFLT(0.0),CFLT(0.0)
	invoke glClear,GL_COLOR_BUFFER_BIT
	invoke glClear,GL_DEPTH_BUFFER_BIT
	
	invoke glMatrixMode,GL_MODELVIEW
	invoke glLoadIdentity
	invoke gluPerspective,CDBL(45.0),CDBL(1.0),CDBL(1.0),CDBL(200.0)
	
	invoke glTranslatef,CFLT(0.0),CFLT(0.0),CFLT(5.0)
	
	invoke glPushMatrix
	invoke glBegin,GL_QUADS
		invoke GetVertex,lpv,0
		invoke glVertex3f,[eax].VERTEX.x,[eax].VERTEX.y,[eax].VERTEX.z
		invoke GetVertex,lpv,1
		invoke glVertex3f,[eax].VERTEX.x,[eax].VERTEX.y,[eax].VERTEX.z
		invoke GetVertex,lpv,2
		invoke glVertex3f,[eax].VERTEX.x,[eax].VERTEX.y,[eax].VERTEX.z
		invoke GetVertex,lpv,3
		invoke glVertex3f,[eax].VERTEX.x,[eax].VERTEX.y,[eax].VERTEX.z
	invoke glEnd
	invoke glPopMatrix
	
	invoke glPushMatrix
	invoke glBegin,GL_QUADS
		invoke GetVertex,lpv,4
		invoke glVertex3f,[eax].VERTEX.x,[eax].VERTEX.y,[eax].VERTEX.z
		invoke GetVertex,lpv,5
		invoke glVertex3f,[eax].VERTEX.x,[eax].VERTEX.y,[eax].VERTEX.z
		invoke GetVertex,lpv,6
		invoke glVertex3f,[eax].VERTEX.x,[eax].VERTEX.y,[eax].VERTEX.z
		invoke GetVertex,lpv,7
		invoke glVertex3f,[eax].VERTEX.x,[eax].VERTEX.y,[eax].VERTEX.z
	invoke glEnd
	invoke glPopMatrix
	
	
;	invoke glBegin,GL_QUADS
;		invoke glTexCoord2f,CFLT(0.0),CFLT(0.0)
;		invoke glVertex2f,CFLT(-1.0),CFLT(-1.0)
;		invoke glTexCoord2f,CFLT(1.0),CFLT(0.0)
;		invoke glVertex2f,CFLT(1.0),CFLT(-1.0)
;		invoke glTexCoord2f,CFLT(1.0),CFLT(1.0)
;		invoke glVertex2f,CFLT(1.0),CFLT(1.0)
;		invoke glTexCoord2f,CFLT(0.0),CFLT(1.0)
;		invoke glVertex2f,CFLT(-1.0),CFLT(1.0)
;	invoke glEnd
	
	invoke SwapBuffers,hDC
	ret
Draw endp

end start